function $parcel$defineInteropFlag(a) {
  Object.defineProperty(a, '__esModule', {value: true, configurable: true});
}
function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}

$parcel$defineInteropFlag(module.exports);

$parcel$export(module.exports, "default", () => $882b6d93070905b3$export$2e2bcd8739ae039);
function $882b6d93070905b3$var$isEmptyOrTrue(value) {
    return value === "" || value === "true";
}
class $882b6d93070905b3$export$2e2bcd8739ae039 extends HTMLElement {
    config = {
        twelvehours: false,
        secondsvisible: false,
        blinking: false,
        separator: ":"
    };
    timeoutHandler = null;
    lastText = "";
    static get observedAttributes() {
        return [
            "twelvehours",
            "secondsvisible",
            "blinking",
            "separator"
        ];
    }
    constructor(){
        super();
    }
    connectedCallback() {
        this.updateConfig();
        if (this.isConnected) this.updateContent();
    }
    disconnectedCallback() {
        if (this.timeoutHandler) clearTimeout(this.timeoutHandler);
    }
    updateConfig() {
        const boolAttributes = [
            "twelvehours",
            "secondsvisible",
            "blinking", 
        ];
        for (const attr of boolAttributes)if ($882b6d93070905b3$var$isEmptyOrTrue(this.getAttribute(attr))) {
            this.config[attr] = true;
            if (this.getAttribute(attr) !== "true") this.setAttribute(attr, "true");
        } else {
            this.config[attr] = false;
            if (this.getAttribute(attr) !== "false") this.setAttribute(attr, "false");
        }
        if (this.hasAttribute("separator")) this.config.separator = this.getAttribute("separator");
        else {
            this.config.separator = ":";
            this.setAttribute("separator", ":");
        }
    }
    attributeChangedCallback() {
        this.updateConfig();
        this.updateContent();
    }
    updateContent() {
        if (this.timeoutHandler) clearTimeout(this.timeoutHandler);
        const currentTime = new Date();
        const newText = this.generateText(currentTime.getHours(), currentTime.getMinutes(), currentTime.getSeconds(), this.config.secondsvisible, this.config.separator, this.config.blinking ? currentTime.getSeconds() % 2 === 0 : true, this.config.twelvehours);
        if (newText !== this.lastText) {
            this.innerText = newText;
            this.lastText = newText;
        }
        if (this.config.blinking || this.config.secondsvisible) this.timeoutHandler = setTimeout(this.updateContent.bind(this), 1000 - currentTime.getMilliseconds());
        else {
            let delta = (60 - currentTime.getSeconds()) * 1000 - currentTime.getMilliseconds();
            if (delta > 1000) delta -= 1000;
            this.timeoutHandler = setTimeout(this.updateContent.bind(this), delta);
        }
    }
    generateText(hours, minutes, seconds, secondsVisible, separator, separatorVisible, twelveHour) {
        let timeString = "";
        let suffix = "";
        let separatorFormatted = separatorVisible ? separator : " ";
        if (twelveHour) {
            timeString += ((hours + 11) % 12 + 1).toString().padStart(2, "0");
            if (hours >= 12) suffix = " PM";
            else suffix = " AM";
        } else timeString += hours.toString().padStart(2, "0");
        timeString += `${separatorFormatted}${minutes.toString().padStart(2, "0")}`;
        if (secondsVisible) timeString += `${separatorFormatted}${seconds.toString().padStart(2, "0")}`;
        timeString += suffix;
        return timeString;
    }
}
window.customElements.define("live-clock", $882b6d93070905b3$export$2e2bcd8739ae039);


//# sourceMappingURL=main.js.map
